Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -1462,123 +1301,134 @@
         return file_desc_fcb(fcb);
 }
 
-void send_notification_fileref(file_ref* fileref, ULONG filter_match, ULONG action) {
+void send_notification_fileref(_In_ file_ref* fileref, _In_ ULONG filter_match, _In_ ULONG action, _In_opt_ PUNICODE_STRING stream) {
     UNICODE_STRING fn;
     NTSTATUS Status;
+    ULONG reqlen;
     USHORT name_offset;
     fcb* fcb = fileref->fcb;
-    
-    Status = fileref_get_filename(fileref, &fn, &name_offset);
+
+    fn.Length = fn.MaximumLength = 0;
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
+    if (Status != STATUS_BUFFER_OVERFLOW) {
+        ERR("fileref_get_filename returned %08x\n", Status);
+        return;
+    }
+
+    if (reqlen > 0xffff) {
+        WARN("reqlen was too long for FsRtlNotifyFilterReportChange\n");
+        return;
+    }
+
+    fn.Buffer = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
+    if (!fn.Buffer) {
+        ERR("out of memory\n");
+        return;
+    }
+
+    fn.MaximumLength = (USHORT)reqlen;
+    fn.Length = 0;
+
+    Status = fileref_get_filename(fileref, &fn, &name_offset, &reqlen);
     if (!NT_SUCCESS(Status)) {
         ERR("fileref_get_filename returned %08x\n", Status);
+        ExFreePool(fn.Buffer);
         return;
     }
-    
+
     FsRtlNotifyFilterReportChange(fcb->Vcb->NotifySync, &fcb->Vcb->DirNotifyList, (PSTRING)&fn, name_offset,
-                                  NULL, NULL, filter_match, action, NULL, NULL);
+                                  (PSTRING)stream, NULL, filter_match, action, NULL, NULL);
     ExFreePool(fn.Buffer);
 }
 
-void send_notification_fcb(file_ref* fileref, ULONG filter_match, ULONG action) {
+void send_notification_fcb(_In_ file_ref* fileref, _In_ ULONG filter_match, _In_ ULONG action, _In_opt_ PUNICODE_STRING stream) {
     fcb* fcb = fileref->fcb;
     LIST_ENTRY* le;
     NTSTATUS Status;
-    
+
     // no point looking for hardlinks if st_nlink == 1
     if (fileref->fcb->inode_item.st_nlink == 1) {
-        send_notification_fileref(fileref, filter_match, action);
+        send_notification_fileref(fileref, filter_match, action, stream);
         return;
     }
-    
+
     ExAcquireResourceExclusiveLite(&fcb->Vcb->fcb_lock, TRUE);
-    
+
     le = fcb->hardlinks.Flink;
     while (le != &fcb->hardlinks) {
         hardlink* hl = CONTAINING_RECORD(le, hardlink, list_entry);
         file_ref* parfr;
-        
+
         Status = open_fileref_by_inode(fcb->Vcb, fcb->subvol, hl->parent, &parfr, NULL);
-        
-        if (!NT_SUCCESS(Status)) {
+
+        if (!NT_SUCCESS(Status))
             ERR("open_fileref_by_inode returned %08x\n", Status);
-        } else if (!parfr->deleted) {
-            LIST_ENTRY* le2;
-            BOOL found = FALSE, deleted = FALSE;
-            UNICODE_STRING* fn;
-            
-            le2 = parfr->children.Flink;
-            while (le2 != &parfr->children) {
-                file_ref* fr2 = CONTAINING_RECORD(le2, file_ref, list_entry);
-                
-                if (fr2->index == hl->index) {
-                    found = TRUE;
-                    deleted = fr2->deleted;
-                    
-                    if (!deleted)
-                        fn = &fr2->filepart;
-                    
-                    break;
-                }
-                
-                le2 = le2->Flink;
+        else if (!parfr->deleted) {
+            UNICODE_STRING fn;
+            ULONG pathlen;
+
+            fn.Length = fn.MaximumLength = 0;
+            Status = fileref_get_filename(parfr, &fn, NULL, &pathlen);
+            if (Status != STATUS_BUFFER_OVERFLOW) {
+                ERR("fileref_get_filename returned %08x\n", Status);
+                free_fileref(fcb->Vcb, parfr);
+                break;
             }
-            
-            if (!found)
-                fn = &hl->name;
-            
-            if (!deleted) {
-                UNICODE_STRING path;
-                
-                Status = fileref_get_filename(parfr, &path, NULL);
-                if (!NT_SUCCESS(Status)) {
-                    ERR("fileref_get_filename returned %08x\n", Status);
-                } else {
-                    UNICODE_STRING fn2;
-                    ULONG name_offset;
-                    
-                    name_offset = path.Length;
-                    if (parfr != fileref->fcb->Vcb->root_fileref) name_offset += sizeof(WCHAR);
-                    
-                    fn2.Length = fn2.MaximumLength = fn->Length + name_offset;
-                    fn2.Buffer = ExAllocatePoolWithTag(PagedPool, fn2.MaximumLength, ALLOC_TAG);
-                    
-                    RtlCopyMemory(fn2.Buffer, path.Buffer, path.Length);
-                    if (parfr != fileref->fcb->Vcb->root_fileref) fn2.Buffer[path.Length / sizeof(WCHAR)] = '\\';
-                    RtlCopyMemory(&fn2.Buffer[name_offset / sizeof(WCHAR)], fn->Buffer, fn->Length);
-                    
-                    TRACE("%.*S\n", fn2.Length / sizeof(WCHAR), fn2.Buffer);
-                    
-                    FsRtlNotifyFilterReportChange(fcb->Vcb->NotifySync, &fcb->Vcb->DirNotifyList, (PSTRING)&fn2, name_offset,
-                                                  NULL, NULL, filter_match, action, NULL, NULL);
-                    
-                    ExFreePool(fn2.Buffer);
-                    ExFreePool(path.Buffer);
-                }
+
+            if (parfr != fcb->Vcb->root_fileref)
+                pathlen += sizeof(WCHAR);
+
+            if (pathlen + hl->name.Length > 0xffff) {
+                WARN("pathlen + hl->name.Length was too long for FsRtlNotifyFilterReportChange\n");
+                free_fileref(fcb->Vcb, parfr);
+                break;
             }
-            
-            free_fileref(parfr);
+
+            fn.MaximumLength = (USHORT)(pathlen + hl->name.Length);
+            fn.Buffer = ExAllocatePoolWithTag(PagedPool, fn.MaximumLength, ALLOC_TAG);
+            if (!fn.Buffer) {
+                ERR("out of memory\n");
+                free_fileref(fcb->Vcb, parfr);
+                break;
+            }
+
+            Status = fileref_get_filename(parfr, &fn, NULL, NULL);
+            if (!NT_SUCCESS(Status)) {
+                ERR("fileref_get_filename returned %08x\n", Status);
+                free_fileref(fcb->Vcb, parfr);
+                ExFreePool(fn.Buffer);
+                break;
+            }
+
+            if (parfr != fcb->Vcb->root_fileref) {
+                fn.Buffer[(pathlen / sizeof(WCHAR)) - 1] = '\\';
+                fn.Length += sizeof(WCHAR);
+            }
+
+            RtlCopyMemory(&fn.Buffer[pathlen / sizeof(WCHAR)], hl->name.Buffer, hl->name.Length);
+            fn.Length += hl->name.Length;
+
+            FsRtlNotifyFilterReportChange(fcb->Vcb->NotifySync, &fcb->Vcb->DirNotifyList, (PSTRING)&fn, (USHORT)pathlen,
+                                          (PSTRING)stream, NULL, filter_match, action, NULL, NULL);
+
+            ExFreePool(fn.Buffer);
+
+            free_fileref(fcb->Vcb, parfr);
         }
-        
+
         le = le->Flink;
     }
-    
+
     ExReleaseResourceLite(&fcb->Vcb->fcb_lock);
 }
 
-void mark_fcb_dirty(fcb* fcb) {
+void mark_fcb_dirty(_In_ fcb* fcb) {
     if (!fcb->dirty) {
 #ifdef DEBUG_FCB_REFCOUNTS
         LONG rc;
 #endif
-        dirty_fcb* dirt = ExAllocatePoolWithTag(NonPagedPool, sizeof(dirty_fcb), ALLOC_TAG);
-        
-        if (!dirt) {
-            ExFreePool("out of memory\n");
-            return;
-        }
-        
         fcb->dirty = TRUE;
-        
+
 #ifdef DEBUG_FCB_REFCOUNTS
         rc = InterlockedIncrement(&fcb->refcount);
         WARN("fcb %p: refcount now %i\n", fcb, rc);
@@ -1585,135 +1435,130 @@
 #else
         InterlockedIncrement(&fcb->refcount);
 #endif
-        
-        dirt->fcb = fcb;
-        
-        ExInterlockedInsertTailList(&fcb->Vcb->dirty_fcbs, &dirt->list_entry, &fcb->Vcb->dirty_fcbs_lock);
+
+        ExAcquireResourceExclusiveLite(&fcb->Vcb->dirty_fcbs_lock, TRUE);
+        InsertTailList(&fcb->Vcb->dirty_fcbs, &fcb->list_entry_dirty);
+        ExReleaseResourceLite(&fcb->Vcb->dirty_fcbs_lock);
     }
-    
+
     fcb->Vcb->need_write = TRUE;
 }
 
-void mark_fileref_dirty(file_ref* fileref) {
+void mark_fileref_dirty(_In_ file_ref* fileref) {
     if (!fileref->dirty) {
-        dirty_fileref* dirt = ExAllocatePoolWithTag(NonPagedPool, sizeof(dirty_fileref), ALLOC_TAG);
-        
-        if (!dirt) {
-            ExFreePool("out of memory\n");
-            return;
-        }
-        
         fileref->dirty = TRUE;
         increase_fileref_refcount(fileref);
-        
-        dirt->fileref = fileref;
-        
-        ExInterlockedInsertTailList(&fileref->fcb->Vcb->dirty_filerefs, &dirt->list_entry, &fileref->fcb->Vcb->dirty_filerefs_lock);
+
+        ExAcquireResourceExclusiveLite(&fileref->fcb->Vcb->dirty_filerefs_lock, TRUE);
+        InsertTailList(&fileref->fcb->Vcb->dirty_filerefs, &fileref->list_entry_dirty);
+        ExReleaseResourceLite(&fileref->fcb->Vcb->dirty_filerefs_lock);
     }
-    
+
     fileref->fcb->Vcb->need_write = TRUE;
 }
 
-void _free_fcb(fcb* fcb, const char* func, const char* file, unsigned int line) {
+#ifdef DEBUG_FCB_REFCOUNTS
+void _free_fcb(_Requires_exclusive_lock_held_(_Curr_->fcb_lock) _In_ device_extension* Vcb, _Inout_ fcb* fcb, _In_ const char* func) {
+#else
+void free_fcb(_Requires_exclusive_lock_held_(_Curr_->fcb_lock) _In_ device_extension* Vcb, _Inout_ fcb* fcb) {
+#endif
     LONG rc;
 
-// #ifdef DEBUG    
-//     if (!ExIsResourceAcquiredExclusiveLite(&fcb->Vcb->fcb_lock) && !ExIsResourceAcquiredExclusiveLite(&fcb->Vcb->tree_lock)) {
-//         ERR("fcb_lock not acquired exclusively\n");
-//         int3;
-//     }
-// #endif
+    rc = InterlockedDecrement(&fcb->refcount);
 
-    rc = InterlockedDecrement(&fcb->refcount);
-    
 #ifdef DEBUG_FCB_REFCOUNTS
-//     WARN("fcb %p: refcount now %i (%.*S)\n", fcb, rc, fcb->full_filename.Length / sizeof(WCHAR), fcb->full_filename.Buffer);
 #ifdef DEBUG_LONG_MESSAGES
-    _debug_message(func, file, line, "fcb %p: refcount now %i (subvol %llx, inode %llx)\n", fcb, rc, fcb->subvol ? fcb->subvol->id : 0, fcb->inode);
+    ERR("fcb %p: refcount now %i (subvol %llx, inode %llx)\n", fcb, rc, fcb->subvol ? fcb->subvol->id : 0, fcb->inode);
 #else
-    _debug_message(func, "fcb %p: refcount now %i (subvol %llx, inode %llx)\n", fcb, rc, fcb->subvol ? fcb->subvol->id : 0, fcb->inode);
+    ERR("fcb %p: refcount now %i (subvol %llx, inode %llx)\n", fcb, rc, fcb->subvol ? fcb->subvol->id : 0, fcb->inode);
 #endif
 #endif
-    
+
     if (rc > 0)
         return;
-    
-//     ExAcquireResourceExclusiveLite(&fcb->Vcb->fcb_lock, TRUE);
-    
+
     if (fcb->list_entry.Flink)
         RemoveEntryList(&fcb->list_entry);
-    
+
     if (fcb->list_entry_all.Flink)
         RemoveEntryList(&fcb->list_entry_all);
-    
-//     ExReleaseResourceLite(&fcb->Vcb->fcb_lock);
-   
+
     ExDeleteResourceLite(&fcb->nonpaged->resource);
     ExDeleteResourceLite(&fcb->nonpaged->paging_resource);
     ExDeleteResourceLite(&fcb->nonpaged->dir_children_lock);
-    ExFreePool(fcb->nonpaged);
-    
+
+    ExFreeToNPagedLookasideList(&Vcb->fcb_np_lookaside, fcb->nonpaged);
+
     if (fcb->sd)
         ExFreePool(fcb->sd);
-    
+
     if (fcb->adsxattr.Buffer)
         ExFreePool(fcb->adsxattr.Buffer);
-    
+
     if (fcb->reparse_xattr.Buffer)
         ExFreePool(fcb->reparse_xattr.Buffer);
-    
+
     if (fcb->ea_xattr.Buffer)
         ExFreePool(fcb->ea_xattr.Buffer);
-    
+
     if (fcb->adsdata.Buffer)
         ExFreePool(fcb->adsdata.Buffer);
-    
+
     if (fcb->debug_desc)
         ExFreePool(fcb->debug_desc);
-    
+
     while (!IsListEmpty(&fcb->extents)) {
         LIST_ENTRY* le = RemoveHeadList(&fcb->extents);
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-        
+
         if (ext->csum)
             ExFreePool(ext->csum);
-        
-        ExFreePool(ext->data);
+
         ExFreePool(ext);
     }
-    
+
     while (!IsListEmpty(&fcb->hardlinks)) {
         LIST_ENTRY* le = RemoveHeadList(&fcb->hardlinks);
         hardlink* hl = CONTAINING_RECORD(le, hardlink, list_entry);
-        
+
         if (hl->name.Buffer)
             ExFreePool(hl->name.Buffer);
-        
+
         if (hl->utf8.Buffer)
             ExFreePool(hl->utf8.Buffer);
 
         ExFreePool(hl);
     }
-    
+
+    while (!IsListEmpty(&fcb->xattrs)) {
+        xattr* xa = CONTAINING_RECORD(RemoveHeadList(&fcb->xattrs), xattr, list_entry);
+
+        ExFreePool(xa);
+    }
+
     while (!IsListEmpty(&fcb->dir_children_index)) {
         LIST_ENTRY* le = RemoveHeadList(&fcb->dir_children_index);
         dir_child* dc = CONTAINING_RECORD(le, dir_child, list_entry_index);
-        
+
         ExFreePool(dc->utf8.Buffer);
         ExFreePool(dc->name.Buffer);
         ExFreePool(dc->name_uc.Buffer);
         ExFreePool(dc);
     }
-    
+
     if (fcb->hash_ptrs)
         ExFreePool(fcb->hash_ptrs);
-    
+
     if (fcb->hash_ptrs_uc)
         ExFreePool(fcb->hash_ptrs_uc);
-    
+
     FsRtlUninitializeFileLock(&fcb->lock);
-    
-    ExFreePool(fcb);
+
+    if (fcb->pool_type == NonPagedPool)
+        ExFreePool(fcb);
+    else
+        ExFreeToPagedLookasideList(&Vcb->fcb_lookaside, fcb);
+
 #ifdef DEBUG_FCB_REFCOUNTS
 #ifdef DEBUG_LONG_MESSAGES
     _debug_message(func, file, line, "freeing fcb %p\n", fcb);
@@ -1723,26 +1568,15 @@
 #endif
 }
 
-void _free_fileref(file_ref* fr, const char* func, const char* file, unsigned int line) {
+void free_fileref(_Requires_exclusive_lock_held_(_Curr_->fcb_lock) _In_ device_extension* Vcb, _Inout_ file_ref* fr) {
     LONG rc;
 
-// #ifdef DEBUG    
-//     if (!ExIsResourceAcquiredExclusiveLite(&fr->fcb->Vcb->fcb_lock) && !ExIsResourceAcquiredExclusiveLite(&fr->fcb->Vcb->tree_lock) && !fr->dirty) {
-//         ERR("fcb_lock not acquired exclusively\n");
-//         int3;
-//     }
-// #endif
+    rc = InterlockedDecrement(&fr->refcount);
 
-    rc = InterlockedDecrement(&fr->refcount);
-    
 #ifdef DEBUG_FCB_REFCOUNTS
-#ifdef DEBUG_LONG_MESSAGES
-    _debug_message(func, file, line, "fileref %p: refcount now %i\n", fr, rc);
-#else
-    _debug_message(func, "fileref %p: refcount now %i\n", fr, rc);
+    ERR("fileref %p: refcount now %i\n", fr, rc);
 #endif
-#endif
-    
+
 #ifdef _DEBUG
     if (rc < 0) {
         ERR("fileref %p: refcount now %i\n", fr, rc);
@@ -1749,126 +1583,147 @@
         int3;
     }
 #endif
-    
+
     if (rc > 0)
         return;
-        
+
     if (fr->parent)
         ExAcquireResourceExclusiveLite(&fr->parent->nonpaged->children_lock, TRUE);
-    
+
     // FIXME - do we need a file_ref lock?
-    
+
     // FIXME - do delete if needed
-    
-    if (fr->filepart.Buffer)
-        ExFreePool(fr->filepart.Buffer);
-    
-    if (fr->filepart_uc.Buffer)
-        ExFreePool(fr->filepart_uc.Buffer);
-    
-    if (fr->utf8.Buffer)
-        ExFreePool(fr->utf8.Buffer);
-    
+
     if (fr->debug_desc)
         ExFreePool(fr->debug_desc);
-    
+
     ExDeleteResourceLite(&fr->nonpaged->children_lock);
-    
-    ExFreePool(fr->nonpaged);
-    
+    ExDeleteResourceLite(&fr->nonpaged->fileref_lock);
+
+    ExFreeToNPagedLookasideList(&Vcb->fileref_np_lookaside, fr->nonpaged);
+
     // FIXME - throw error if children not empty
-    
+
     if (fr->fcb->fileref == fr)
         fr->fcb->fileref = NULL;
-    
-    if (fr->dc)
+
+    if (fr->dc) {
+        if (fr->fcb->ads)
+            fr->dc->size = fr->fcb->adsdata.Length;
+
         fr->dc->fileref = NULL;
+    }
 
     if (fr->list_entry.Flink)
         RemoveEntryList(&fr->list_entry);
-    
+
     if (fr->parent) {
         ExReleaseResourceLite(&fr->parent->nonpaged->children_lock);
-        free_fileref(fr->parent);
+        free_fileref(Vcb, fr->parent);
     }
-    
-    free_fcb(fr->fcb);
-    ExFreePool(fr);
+
+    free_fcb(Vcb, fr->fcb);
+
+    ExFreeToPagedLookasideList(&Vcb->fileref_lookaside, fr);
 }
 
-static NTSTATUS STDCALL close_file(device_extension* Vcb, PFILE_OBJECT FileObject) {
+static NTSTATUS close_file(_In_ PFILE_OBJECT FileObject, _In_ PIRP Irp) {
     fcb* fcb;
     ccb* ccb;
     file_ref* fileref = NULL;
     LONG open_files;
-    
+    device_extension* Vcb;
+
+    UNUSED(Irp);
+
     TRACE("FileObject = %p\n", FileObject);
-    
-    open_files = InterlockedDecrement(&Vcb->open_files);
-    
+
     fcb = FileObject->FsContext;
     if (!fcb) {
         TRACE("FCB was NULL, returning success\n");
-        
-        if (open_files == 0 && Vcb->removing)
-            uninit(Vcb, FALSE);
-        
         return STATUS_SUCCESS;
     }
-    
+
+    open_files = InterlockedDecrement(&fcb->Vcb->open_files);
+
     ccb = FileObject->FsContext2;
-    
+
     TRACE("close called for %S (fcb == %p)\n", file_desc(FileObject), fcb);
-    
+
     // FIXME - make sure notification gets sent if file is being deleted
-    
-    if (ccb) {    
+
+    if (ccb) {
         if (ccb->query_string.Buffer)
             RtlFreeUnicodeString(&ccb->query_string);
-        
+
         if (ccb->filename.Buffer)
             ExFreePool(ccb->filename.Buffer);
-        
+
         // FIXME - use refcounts for fileref
         fileref = ccb->fileref;
-        
+
+        if (fcb->Vcb->running_sends > 0) {
+            BOOL send_cancelled = FALSE;
+
+            ExAcquireResourceExclusiveLite(&fcb->Vcb->send_load_lock, TRUE);
+
+            if (ccb->send) {
+                ccb->send->cancelling = TRUE;
+                send_cancelled = TRUE;
+                KeSetEvent(&ccb->send->cleared_event, 0, FALSE);
+            }
+
+            ExReleaseResourceLite(&fcb->Vcb->send_load_lock);
+
+            if (send_cancelled) {
+                while (ccb->send) {
+                    ExAcquireResourceExclusiveLite(&fcb->Vcb->send_load_lock, TRUE);
+                    ExReleaseResourceLite(&fcb->Vcb->send_load_lock);
+                }
+            }
+        }
+
         ExFreePool(ccb);
     }
-    
+
     CcUninitializeCacheMap(FileObject, NULL, NULL);
-    
-    if (open_files == 0 && Vcb->removing) {
-        uninit(Vcb, FALSE);
+
+    if (open_files == 0 && fcb->Vcb->removing) {
+        uninit(fcb->Vcb, FALSE);
         return STATUS_SUCCESS;
     }
-    
-    if (!(Vcb->Vpb->Flags & VPB_MOUNTED))
+
+    if (!(fcb->Vcb->Vpb->Flags & VPB_MOUNTED))
         return STATUS_SUCCESS;
-    
+
+    Vcb = fcb->Vcb;
+
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-    
+
     if (fileref)
-        free_fileref(fileref);
+        free_fileref(fcb->Vcb, fileref);
     else
-        free_fcb(fcb);
-    
+        free_fcb(Vcb, fcb);
+
     ExReleaseResourceLite(&Vcb->fcb_lock);
-    
+
     return STATUS_SUCCESS;
 }
 
-void STDCALL uninit(device_extension* Vcb, BOOL flush) {
-    space* s;
+void uninit(_In_ device_extension* Vcb, _In_ BOOL flush) {
     UINT64 i;
-    LIST_ENTRY rollback;
     NTSTATUS Status;
     LIST_ENTRY* le;
     LARGE_INTEGER time;
-    
-    Vcb->removing = TRUE;
-    
+
+    if (!Vcb->removing) {
+        ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+        Vcb->removing = TRUE;
+        ExReleaseResourceLite(&Vcb->tree_lock);
+    }
+
     RemoveEntryList(&Vcb->list_entry);
-    
+
     if (Vcb->balance.thread) {
         Vcb->balance.paused = FALSE;
         Vcb->balance.stopping = TRUE;
@@ -1875,164 +1730,227 @@
         KeSetEvent(&Vcb->balance.event, 0, FALSE);
         KeWaitForSingleObject(&Vcb->balance.finished, Executive, KernelMode, FALSE, NULL);
     }
-    
+
+    if (Vcb->scrub.thread) {
+        Vcb->scrub.paused = FALSE;
+        Vcb->scrub.stopping = TRUE;
+        KeSetEvent(&Vcb->scrub.event, 0, FALSE);
+        KeWaitForSingleObject(&Vcb->scrub.finished, Executive, KernelMode, FALSE, NULL);
+    }
+
+    if (Vcb->running_sends != 0) {
+        BOOL send_cancelled = FALSE;
+
+        ExAcquireResourceExclusiveLite(&Vcb->send_load_lock, TRUE);
+
+        le = Vcb->send_ops.Flink;
+        while (le != &Vcb->send_ops) {
+            send_info* send = CONTAINING_RECORD(le, send_info, list_entry);
+
+            if (!send->cancelling) {
+                send->cancelling = TRUE;
+                send_cancelled = TRUE;
+                send->ccb = NULL;
+                KeSetEvent(&send->cleared_event, 0, FALSE);
+            }
+
+            le = le->Flink;
+        }
+
+        ExReleaseResourceLite(&Vcb->send_load_lock);
+
+        if (send_cancelled) {
+            while (Vcb->running_sends != 0) {
+                ExAcquireResourceExclusiveLite(&Vcb->send_load_lock, TRUE);
+                ExReleaseResourceLite(&Vcb->send_load_lock);
+            }
+        }
+    }
+
     Status = registry_mark_volume_unmounted(&Vcb->superblock.uuid);
     if (!NT_SUCCESS(Status) && Status != STATUS_TOO_LATE)
         WARN("registry_mark_volume_unmounted returned %08x\n", Status);
-    
+
     if (flush) {
-        InitializeListHead(&rollback);
-        
         ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
 
-        if (Vcb->need_write && !Vcb->readonly)
-            do_write(Vcb, NULL, &rollback);
-        
+        if (Vcb->need_write && !Vcb->readonly) {
+            Status = do_write(Vcb, NULL);
+            if (!NT_SUCCESS(Status))
+                ERR("do_write returned %08x\n", Status);
+        }
+
         free_trees(Vcb);
-        
-        clear_rollback(Vcb, &rollback);
 
         ExReleaseResourceLite(&Vcb->tree_lock);
     }
-    
+
     for (i = 0; i < Vcb->calcthreads.num_threads; i++) {
         Vcb->calcthreads.threads[i].quit = TRUE;
     }
-    
+
     KeSetEvent(&Vcb->calcthreads.event, 0, FALSE);
-        
+
     for (i = 0; i < Vcb->calcthreads.num_threads; i++) {
         KeWaitForSingleObject(&Vcb->calcthreads.threads[i].finished, Executive, KernelMode, FALSE, NULL);
-        
+
         ZwClose(Vcb->calcthreads.threads[i].handle);
     }
-    
+
     ExDeleteResourceLite(&Vcb->calcthreads.lock);
     ExFreePool(Vcb->calcthreads.threads);
-    
+
     time.QuadPart = 0;
     KeSetTimer(&Vcb->flush_thread_timer, time, NULL); // trigger the timer early
     KeWaitForSingleObject(&Vcb->flush_thread_finished, Executive, KernelMode, FALSE, NULL);
-    
-    free_fcb(Vcb->volume_fcb);
-    
+
+    ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+    free_fcb(Vcb, Vcb->volume_fcb);
+    free_fcb(Vcb, Vcb->dummy_fcb);
+    ExReleaseResourceLite(&Vcb->fcb_lock);
+
     if (Vcb->root_file)
         ObDereferenceObject(Vcb->root_file);
-    
+
     le = Vcb->chunks.Flink;
     while (le != &Vcb->chunks) {
         chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
-        
+
         if (c->cache) {
-            free_fcb(c->cache);
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fcb(Vcb, c->cache);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
             c->cache = NULL;
         }
-        
+
         le = le->Flink;
     }
 
     while (!IsListEmpty(&Vcb->roots)) {
-        LIST_ENTRY* le = RemoveHeadList(&Vcb->roots);
-        root* r = CONTAINING_RECORD(le, root, list_entry);
+        root* r = CONTAINING_RECORD(RemoveHeadList(&Vcb->roots), root, list_entry);
 
         ExDeleteResourceLite(&r->nonpaged->load_tree_lock);
         ExFreePool(r->nonpaged);
         ExFreePool(r);
     }
-    
+
     while (!IsListEmpty(&Vcb->chunks)) {
-        chunk* c;
-        
-        le = RemoveHeadList(&Vcb->chunks);
-        c = CONTAINING_RECORD(le, chunk, list_entry);
-        
+        chunk* c = CONTAINING_RECORD(RemoveHeadList(&Vcb->chunks), chunk, list_entry);
+
         while (!IsListEmpty(&c->space)) {
             LIST_ENTRY* le2 = RemoveHeadList(&c->space);
-            s = CONTAINING_RECORD(le2, space, list_entry);
-            
+            space* s = CONTAINING_RECORD(le2, space, list_entry);
+
             ExFreePool(s);
         }
-        
+
         while (!IsListEmpty(&c->deleting)) {
             LIST_ENTRY* le2 = RemoveHeadList(&c->deleting);
-            s = CONTAINING_RECORD(le2, space, list_entry);
-            
+            space* s = CONTAINING_RECORD(le2, space, list_entry);
+
             ExFreePool(s);
         }
-        
+
         if (c->devices)
             ExFreePool(c->devices);
-        
-        if (c->cache)
-            free_fcb(c->cache);
-        
+
+        if (c->cache) {
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fcb(Vcb, c->cache);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+        }
+
+        ExDeleteResourceLite(&c->range_locks_lock);
+        ExDeleteResourceLite(&c->partial_stripes_lock);
         ExDeleteResourceLite(&c->lock);
         ExDeleteResourceLite(&c->changed_extents_lock);
-        
+
         ExFreePool(c->chunk_item);
         ExFreePool(c);
     }
-    
+
     // FIXME - free any open fcbs?
-    
+
     while (!IsListEmpty(&Vcb->devices)) {
-        LIST_ENTRY* le = RemoveHeadList(&Vcb->devices);
-        device* dev = CONTAINING_RECORD(le, device, list_entry);
-        
+        device* dev = CONTAINING_RECORD(RemoveHeadList(&Vcb->devices), device, list_entry);
+
         while (!IsListEmpty(&dev->space)) {
             LIST_ENTRY* le2 = RemoveHeadList(&dev->space);
             space* s = CONTAINING_RECORD(le2, space, list_entry);
-            
+
             ExFreePool(s);
         }
-        
+
         ExFreePool(dev);
     }
-    
+
+    ExAcquireResourceExclusiveLite(&Vcb->scrub.stats_lock, TRUE);
+    while (!IsListEmpty(&Vcb->scrub.errors)) {
+        scrub_error* err = CONTAINING_RECORD(RemoveHeadList(&Vcb->scrub.errors), scrub_error, list_entry);
+
+        ExFreePool(err);
+    }
+    ExReleaseResourceLite(&Vcb->scrub.stats_lock);
+
     ExDeleteResourceLite(&Vcb->fcb_lock);
     ExDeleteResourceLite(&Vcb->load_lock);
     ExDeleteResourceLite(&Vcb->tree_lock);
     ExDeleteResourceLite(&Vcb->chunk_lock);
-    
+    ExDeleteResourceLite(&Vcb->dirty_fcbs_lock);
+    ExDeleteResourceLite(&Vcb->dirty_filerefs_lock);
+    ExDeleteResourceLite(&Vcb->dirty_subvols_lock);
+    ExDeleteResourceLite(&Vcb->scrub.stats_lock);
+    ExDeleteResourceLite(&Vcb->send_load_lock);
+
     ExDeletePagedLookasideList(&Vcb->tree_data_lookaside);
     ExDeletePagedLookasideList(&Vcb->traverse_ptr_lookaside);
-    ExDeletePagedLookasideList(&Vcb->rollback_item_lookaside);
     ExDeletePagedLookasideList(&Vcb->batch_item_lookaside);
+    ExDeletePagedLookasideList(&Vcb->fileref_lookaside);
+    ExDeletePagedLookasideList(&Vcb->fcb_lookaside);
+    ExDeletePagedLookasideList(&Vcb->name_bit_lookaside);
     ExDeleteNPagedLookasideList(&Vcb->range_lock_lookaside);
-    
+    ExDeleteNPagedLookasideList(&Vcb->fileref_np_lookaside);
+    ExDeleteNPagedLookasideList(&Vcb->fcb_np_lookaside);
+
     ZwClose(Vcb->flush_thread_handle);
 }
 
-NTSTATUS delete_fileref(file_ref* fileref, PFILE_OBJECT FileObject, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS delete_fileref(_In_ file_ref* fileref, _In_ PFILE_OBJECT FileObject, _In_opt_ PIRP Irp, _In_ LIST_ENTRY* rollback) {
     LARGE_INTEGER newlength, time;
     BTRFS_TIME now;
     NTSTATUS Status;
+    ULONG utf8len = 0;
 
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
 
     ExAcquireResourceExclusiveLite(fileref->fcb->Header.Resource, TRUE);
-    
+
     if (fileref->deleted) {
         ExReleaseResourceLite(fileref->fcb->Header.Resource);
         return STATUS_SUCCESS;
     }
-    
+
+    if (fileref->fcb->subvol->send_ops > 0) {
+        ExReleaseResourceLite(fileref->fcb->Header.Resource);
+        return STATUS_ACCESS_DENIED;
+    }
+
     fileref->deleted = TRUE;
     mark_fileref_dirty(fileref);
-    
+
     // delete INODE_ITEM (0x1)
 
     TRACE("nlink = %u\n", fileref->fcb->inode_item.st_nlink);
-    
+
     if (!fileref->fcb->ads) {
         if (fileref->parent->fcb->subvol == fileref->fcb->subvol) {
             LIST_ENTRY* le;
-            
+
             mark_fcb_dirty(fileref->fcb);
-            
+
             fileref->fcb->inode_item_changed = TRUE;
-            
+
             if (fileref->fcb->inode_item.st_nlink > 1) {
                 fileref->fcb->inode_item.st_nlink--;
                 fileref->fcb->inode_item.transid = fileref->fcb->Vcb->superblock.generation;
@@ -2039,10 +1957,8 @@
                 fileref->fcb->inode_item.sequence++;
                 fileref->fcb->inode_item.st_ctime = now;
             } else {
-                fileref->fcb->deleted = TRUE;
-            
                 // excise extents
-                
+
                 if (fileref->fcb->type != BTRFS_TYPE_DIRECTORY && fileref->fcb->inode_item.st_size > 0) {
                     Status = excise_extents(fileref->fcb->Vcb, fileref->fcb, 0, sector_align(fileref->fcb->inode_item.st_size, fileref->fcb->Vcb->superblock.sector_size), Irp, rollback);
                     if (!NT_SUCCESS(Status)) {
